{% extends 'base.html' %}
{% load static %}

{% block content %}
    <div class="position-relative container rounded" style="background-color: white;">

        <ul class="nav nav-tabs" id="homePageFilterTabs" role="tablist">
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_updated' %}" class="nav-link" id="updated-tab" aria-current="page">
                    Updated
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_simulcast' %}" class="nav-link" id="simulcast-tab" aria-current="page">
                    Simulcasts
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_popular' %}" class="nav-link" id="popular-tab" aria-current="page">
                    Popular
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_category' %}" class="nav-link" id="category-tab" aria-current="page">
                    Categories
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_genre' %}" class="nav-link" id="genre-tab" aria-current="page">
                    Genres
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_season' %}" class="nav-link" id="genre-tab" aria-current="page">
                    Seasons
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_alphabetical' %}" class="nav-link" id="alphabetical-tab" aria-current="page">
                    Alphabetical
                </a>
            </li>
            <li class="nav-item" role="presentation">
                <a href="{% url 'v_premium' %}" class="nav-link" id="premium-tab" aria-current="page">
                    Premium
                </a>
            </li>
        </ul>

        {% block popularFilter %}{% endblock %}

        {% block categoryFilter %}{% endblock %}

        {% block genreFilter %}{% endblock %}

        {% block seasonFilter %}{% endblock %}

        {% block alphabeticFilter %}{% endblock %}

        <form action="{% url 'v_anime_detail' %}" method="get">
            <div class="album py-3">
                <div class="container">
                    <div id="animeCardContainer" class="row row-cols-1 row-cols-sm-2 row-cols-md-4 g-3">
                        {% for a in anime %}
                            {% if inUpdated %}
                                {% block updatedContent %}{% endblock %}
                            {% elif inPopular %}
                                {% block popularContent %}{% endblock %}
                            {% else %}
                                {% include 'animeflix_app/videoSections/animeCard.html' %}
                            {% endif %}
                        {% endfor %}
                    </div>
                </div>
                <div id="loadingSpinner" class="d-grid gap-2 col-6 mx-auto mt-3 justify-content-center not-visible">
                    <div class="lds-ripple">
                        <div></div>
                        <div></div>
                    </div>
                </div>
                {% block loadMoreButton %}{% endblock %}
            </div>
        </form>
    </div>

    <script defer>
        const loadMoreDataButton = document.getElementById('loadMoreData');
        const animeCardContainer = document.getElementById('animeCardContainer');
        const ldSpinner = document.getElementById('loadingSpinner');
        let visible = {{ anime_limit }};
        const premiumBadgeSrc = '{% static 'icons/workspace_premium_black.svg' %}';
        {% block selectedGenres %}{% endblock%}

        const makeAjaxCall = () => {
            const loadMoreUrl = '{% url 'load_more' %}';
            const popularOrder = location.href.includes('low')? 'low':'high';
            $.ajax({
                type: 'GET',
                url: `${loadMoreUrl}`,
                data: {
                    num_cards: visible,
                    loadMoreAnime: "{{ loadMoreName }}",
                    offset: {{ anime_limit }},
                    order: popularOrder,
                    {% block selectedGenresAjax %}{% endblock %}
                },
                traditional: true,
                dataType: 'json',
                beforeSend: function () {
                    console.log('%cAjax call, in loading more data, Sended!', 'color:#00FFFF;font-weight:bold;font-size:15px');
                },
                success: function (res) {
                    console.log('%cSUCCESS!', 'color:#7FFF00;font-weight:bold;font-size:15px');
                    const isMaxed = res.isMaxed;
                    const moreAnime = res.moreAnime;
                    const inPopular = res.inPopular;
                    ldSpinner.classList.remove('not-visible');
                    setTimeout(() => {
                        if (isMaxed) {
                            console.log('%cNo more to load!', 'color:#ff9933;font-weight:bold;font-size:15px');
                            loadMoreDataButton.classList.add('not-visible');
                        } else {
                            Object.entries(moreAnime).forEach(ani => {
                                const anime = ani[1];
                                if (anime.premium) {
                                    animeCardContainer.innerHTML +=
                                        `<div class="col cardColumn" id="cardID_${anime.id}">
                                                    <div class="card shadow-sm">
                                                        <div class="card-body position-relative">
                                                            <div class="text-center mb-3">
                                                                <img src="${anime.copertina}" alt="${anime.copertina}" class="img-fluid">
                                                            </div>
                                                            <div class="d-flex justify-content-center">
                                                                <h5 class="card-text text-dark mx-auto">${anime.titolo}</h5>
                                                                <img class="img-fluid rounded-circle white-img-filter bg-primary p-1"
                                                                    src="${premiumBadgeSrc}" alt="premium_icon">
                                                            </div>
                                                            <p class="card-text text-center text-truncate">${anime.trama}</p>
                                                            <div class="align-items-center text-center">
                                                                <small class="text-muted">${anime.tot_episodi} Episodes</small>
                                                            </div>
                                                        </div>
                                                        <button type="submit" class="btn btn-primary" name="watch" value="${anime.id}">Watch it!</button>
                                                    </div>
                                                </div>`;
                                } else {
                                    animeCardContainer.innerHTML +=
                                        `<div class="col cardColumn" id="cardID_${anime.id}">
                                                <div class="card shadow-sm">
                                                    <div class="card-body position-relative">
                                                        <div class="text-center mb-3">
                                                            <img src="${anime.copertina}" alt="${anime.copertina}" class="img-fluid">
                                                        </div>
                                                        <h5 class="card-text text-center" style="color: black">${anime.titolo}</h5>
                                                        <p class="card-text text-center text-truncate">${anime.trama}</p>
                                                        <div class="align-items-center text-center">
                                                            <small class="text-muted">${anime.tot_episodi} Episodes</small>
                                                        </div>
                                                    </div>
                                                    <button type="submit" class="btn btn-primary" name="watch" value="${anime.id}">Watch it!</button>
                                                </div>
                                            </div>`;
                                }
                            });
                        }
                        ldSpinner.classList.add('not-visible');
                    }, 500);
                },
                error: function (err) {
                    console.log('%cAjax call, in loading more data, failed!', 'color:red;font-weight:bold;font-size:15px');
                    console.log(err);
                }
            });
        }

        // Load more data
        $('#loadMoreData').on('click', function () {
                console.log('CLICKED');
                visible += {{ anime_limit }};
                makeAjaxCall();
            }
        );
    </script>
{% endblock content %}